<html>

<head>

<title>Postfix Anatomy - Behind the Scenes</title>

<META NAME="ROBOTS" CONTENT="NOINDEX,NOFOLLOW">
</head>

<body background="obsolete.gif">

<h1><a href="big-picture.html"><img src="small-picture.gif" width="115" height="45"></a> Postfix
Anatomy - Behind the Scenes</h1>

<hr>

<p> <strong> Note: this web page is no longer maintained. It exists
only to avoid breaking links in web pages that describe earlier
versions of the Postfix mail system. </strong> </p>

<a href="docs.html">Up one level</a> | <a
href="receiving.html">Receiving Mail</a> | <a
href="delivering.html">Delivering Mail</a> | Behind the Scenes |
<a href="commands.html">Command-line Utilities</a>

<p>

The previous sections gave a simplified overview of how the Postfix
system sends and receives mail. Several other things happen behind
the scenes. Unfortunately, this is hard to visualize on a
two-dimensional display, so this document has no illustration.

<ul>

<li>The <a href="master.8.html">master</a> daemon is the supervisor
process that keeps an eye on the well-being of the mail system. It
is typically started at system boot time by the <a
href="postfix.1.html">postfix</a> command, and keeps running until
the system goes down.  The <a href="master.8.html">master</a> daemon
is responsible for starting all other Postfix daemon processes on
demand, and for restarting daemons that terminated prematurely
because of some problem. The <a href="master.8.html">master</a>
daemon is also responsible for enforcing the daemon process count
limits as specified in the <b>master.cf</b> configuration file.

<p>

<li>The <a href="bounce.8.html">bounce or defer</a> daemon is called
upon left and right by other daemon processes, in order to maintain
per-message log files with non-delivery status information.

<p>

<li>The <a href="trivial-rewrite.8.html">trivial-rewrite</a> daemon
is called upon left and right by other daemon processes, in order
to rewrite an address to <i>user@fully.qualified.domain</i> form,
or in order to resolve a destination.

<p>

<li>The <a href="showq.8.html">showq</a> daemon lists the Postfix
queue status. This is the program behind the <a
href="mailq.1.html">mailq</a> command.

<p>

<li>The <a href="flush.8.html">flush</a> daemon improves the
performance of the SMTP <b>ETRN</b> request, and of its command-line
equivalent, <b>sendmail -qR</b><i>destination</i>, for selected
destinations.

<p>

<li>The <a href="proxymap.8.html">proxymap</a> daemon provides
read-only lookup service to Postfix client processes. The purpose
is to overcome chroot restrictions, and to consolidate the number
of open lookup tables by sharing one open table among multiple
processes.

<p>

<li>The <a href="spawn.8.html">spawn</a> daemon listens on a TCP
port, UNIX-domain socket or FIFO, and runs non-Postfix commands on
request, with the socket or FIFO connected to the standard input,
output and error streams.  It is currently used only in an example
of the Postfix external content filtering system.

</ul>

<hr>

<a href="docs.html">Up one level</a> | <a
href="receiving.html">Receiving Mail</a> | <a
href="delivering.html">Delivering Mail</a> | Behind the Scenes |
<a href="commands.html">Command-line Utilities</a>

</body>

</html>
